      list p=16f877                 ; list directive to define processor
      #include <p16f877.inc>        ; processor specific variable definitions
      __CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_ON & _CPD_OFF & _LVP_ON

      #include <lcd.inc>			   ;Import LCD control functions from lcd.asm

	udata_shr
	COUNTH	res 1	;const used in delay
	COUNTM	res	1	;const used in delay
	COUNTL	res	1	;const used in delay
	Table_Counter	res	1
	

         ORG       0x0000     ;RESET vector must always be at 0x00
         goto      init       ;Just jump to the main code section.
         
;***************************************
; Display macro
;***************************************
Display macro	Message
		local	loop_
		local 	end_
		clrf	Table_Counter
		clrw		
loop_	movf	Table_Counter,W
		call 	Message
		xorlw	B'00000000' ;check WORK reg to see if 0 is returned
		btfsc	STATUS,Z
			goto	end_
		call	WR_DATA
		incf	Table_Counter,F
		goto	loop_
end_
		endm

;***************************************
; Initialize LCD
;***************************************
init
         clrf      INTCON         ; No interrupts

         bsf       STATUS,RP0     ; select bank 1
         clrf      TRISA          ; All port A is output
         movlw     b'11110010'    ; Set required keypad inputs
         movwf     TRISB
         clrf      TRISC          ; All port C is output
         clrf      TRISD          ; All port D is output

         bcf       STATUS,RP0     ; select bank 0
         clrf      PORTA
         clrf      PORTB
         clrf      PORTC
         clrf      PORTD
          
         call      InitLCD  	  ;Initialize the LCD (code in lcd.asm; imported by lcd.inc)

;***************************************
; Main code
;***************************************
Main	Display		Welcome_Msg

;SwtichLine
;		call		Switch_Lines
;		Display		Welcome_Msg

;ChangeToQuestionMark
;		movlw		b'11001011'
;		call		WR_INS
;		movlw		"?"
;		call		WR_DATA

;ShiftDisplayLeft
;		call		Clear_Display
;
;		Display		Alphabet
;
;Left	movlw		b'00011000'		;Move to the left
;		call		WR_INS
;		call		HalfS
;		goto		Left			;repeat operation
;		
		goto	$


;***************************************
; Look up table
;***************************************

Welcome_Msg	
		addwf	PCL,F
		dt		"Hello World!", 0

Alphabet
		addwf	PCL,F
		dt		"ABCDEFGHIJKLMNOPQRSTUVWXYZ",0

;***************************************
; LCD control
;***************************************
Switch_Lines
		movlw	B'11000000'
		call	WR_INS
		return

Clear_Display
		movlw	B'00000001'
		call	WR_INS
		return

;***************************************
; Delay 0.5s
;***************************************
HalfS	
	local	HalfS_0
      movlw 0x88
      movwf COUNTH
      movlw 0xBD
      movwf COUNTM
      movlw 0x03
      movwf COUNTL

HalfS_0
      decfsz COUNTH, f
      goto   $+2
      decfsz COUNTM, f
      goto   $+2
      decfsz COUNTL, f
      goto   HalfS_0

      goto $+1
      nop
      nop
		return

          END
